/* $Id: mlog.h 548 2008-05-14 10:14:13Z gloomy $ */

#ifndef __PARSEC_LOG_H_INCLUDED__
#define __PARSEC_LOG_H_INCLUDED__

#include <sys/types.h>
#include <stdint.h>

#include <parsec/common.h>

typedef uint32_t eid_t; /* audit event id */

#define PARSEC_LOG_EID_INVALID	(0)

#define PARSEC_LOG_EID_SOURCE(v)	(((v)&0xf0000000)>>28)
#define PARSEC_LOG_EID_NVAR(v)	((v)&0xf)
#define PARSEC_LOG_EID_NVAR_MAX	(0xf)

#define PARSEC_LOG_EID_SOURCE_USER		0
#define PARSEC_LOG_EID_SOURCE_KERNEL_PS		1
#define PARSEC_LOG_EID_SOURCE_KERNEL_FS		2
#define PARSEC_LOG_EID_SOURCE_USER_CUSTOM		3
/* 4-0xf -- reserved */
#define PARSEC_LOG_EID_SOURCE_UNKNOWN		4
#define PARSEC_LOG_EID_SOURCE_MAX			0xf
#define PARSEC_LOG_EID_SOURCE_NUM			(PARSEC_LOG_EID_SOURCE_MAX + 1)

#define PARSEC_LOG_EID(id,s,n)		\
	((((PARSEC_LOG_EID_SOURCE_##s)&0xf)<<28) |\
	 ((n) &0xf) | (id<<4))

#define _S(s)	strlen((s)), (s)
#define	_A(a)	sizeof(*(a)), (a)
#define _V(v)	sizeof(__typeof__(v)), &(v) 
#define _D(a,s) (s), (a)

#define PARSEC_LOG_STATUS_SUCCESS		0
#define PARSEC_LOG_STATUS_FAIL		1

#define PARSEC_LOG_SEND(name, status, arg...) \
	parsec_log_send(PARSEC_LOG_EVENT_##name,\
			PARSEC_LOG_STATUS_##status,##arg)
/* example:
   PARSEC_AUDIT_SEND(OPEN, SUCCESS, _V("/etc/shadow"),_V(mode));
extern int parsec_log_send(eid_t, uint16_t status, ...); 
   parameters as pairs: size vs data and so on... */

#ifdef __cplusplus
extern "C" {
#endif
	extern int	parsec_log_send(eid_t eid, uint16_t status, ...);
	extern int	mlog_init(void); /* deprecated */
	extern void	mlog_done(void); /* deprecated */
#ifdef __cplusplus
}
#endif

/* user mode events */
#define PARSEC_LOG_EVENT_MESSAGE PARSEC_LOG_EID(1,USER,1)

#endif // __PARSEC_LOG_H_INCLUDED__

